// Block.cpp
// Alfredo Porras, Brian Seney
// IMGD 3000

#include "Block.h"

#include "Engine/WorldManager.h"
#include "Engine/GraphicsManager.h"

Block::Block() {
	is_solid = true;
	object_type = "block";
	block_type = "simple";

	WorldManager &world_manager = WorldManager::getInstance();
	world_manager.addObj(this);
}

Block::Block(Position p) {
	is_solid = true;
	object_type = "block";
	block_type = "simple";

	WorldManager &world_manager = WorldManager::getInstance();
	world_manager.addObj(this);
	world_manager.moveObj(this, p);
}

Block::~Block() {}

void Block::draw(){
	GraphicsManager &graphics_manager = GraphicsManager::getInstance();
	graphics_manager.drawCh(pos, ' ', 56);
}

string Block::getBlockType() {
	return block_type;
}
	
