// BlockBreakable.cpp
// Alfredo Porras, Brian Seney
// IMGD 3000

#include "BlockBreakable.h"
#include "Bullet.h"

#include "Engine/GraphicsManager.h"

BlockBreakable::BlockBreakable() {
	block_type = "breakable";

	// Don't add to world (done in base class)
	EventManager &event_manager = EventManager::getInstance();
	event_manager.registerInterest(this, COLLISION_EVENT);
}

BlockBreakable::BlockBreakable(Position p, int res) {
	resistance = res;

	block_type = "breakable";

	// Don't add to world (done in base class)
	WorldManager &world_manager = WorldManager::getInstance();
	world_manager.moveObj(this, p);

	EventManager &event_manager = EventManager::getInstance();
	event_manager.registerInterest(this, COLLISION_EVENT);
}

BlockBreakable::~BlockBreakable() {
	EventManager &event_manager = EventManager::getInstance();
	event_manager.removeInterest(this, COLLISION_EVENT);
}

int BlockBreakable::eventHandler(Event *p_e) {
	if (p_e->getType().compare( COLLISION_EVENT ) == 0){
		EventCollision *p_collision = static_cast <EventCollision *> (p_e);
		getHit(p_collision);
		return 1;
	}
	return 0;
}

void BlockBreakable::getHit(EventCollision *p_ce) {
	GameObject *p_go = p_ce->getObj2();
	if (p_go->getType().compare(BULLET_TYPE) == 0) {
	resistance -= static_cast <Bullet *>(p_go)->getDamage();
		if (resistance <= 0) {
			WorldManager &world_manager = WorldManager::getInstance();
			world_manager.markForDelete(this);
		}
	}
}

void BlockBreakable::draw(){
	GraphicsManager &graphics_manager = GraphicsManager::getInstance();
	graphics_manager.drawCh(pos, '#', 0); // 56?
}
