// BlockMovable.cpp
// Alfredo Porras, Brian Seney
// IMGD 3000

#include "BlockMovable.h"
#include "Weapon.h"

#include "Engine/GraphicsManager.h"
#include "Engine/LogManager.h"

BlockMovable::BlockMovable() {
	block_type = "movable";

	// Don't add to world (done in base class)
	EventManager &event_manager = EventManager::getInstance();
	event_manager.registerInterest(this, COLLISION_EVENT);
}

BlockMovable::BlockMovable(Position p) {
	block_type = "movable";

	// Don't add to world (done in base class)
	WorldManager &world_manager = WorldManager::getInstance();
	world_manager.moveObj(this, p);

	EventManager &event_manager = EventManager::getInstance();
	event_manager.registerInterest(this, COLLISION_EVENT);
}

BlockMovable::~BlockMovable() {
	EventManager &event_manager = EventManager::getInstance();
	event_manager.removeInterest(this, COLLISION_EVENT);
}

void BlockMovable::draw(){
	GraphicsManager &graphics_manager = GraphicsManager::getInstance();
	graphics_manager.drawCh(pos, 'M', 0); // 56?
}
