// EndGamePicture.cpp
// Brian Seney, Alfredo Porras
// IMGD3000

#include "EndGamePicture.h"
#include "Engine/WorldManager.h"
#include "Engine/EventManager.h"
#include "Engine/EventKeyboard.h"

EndGamePicture::EndGamePicture(Sprite *spr_ptr){
	if(spr_ptr)
		sprite_ptr = spr_ptr;

	WorldManager &world_manager = WorldManager::getInstance();
	world_manager.addObj(this);

	EventManager &event_manager = EventManager::getInstance();
	event_manager.registerInterest(this, KEYBOARD_EVENT);
}

EndGamePicture::~EndGamePicture(){
	EventManager &event_manager = EventManager::getInstance();
	event_manager.removeInterest(this, KEYBOARD_EVENT);
}

int EndGamePicture::eventHandler(Event *event_ptr){
	if(event_ptr->getType().compare(KEYBOARD_EVENT) == 0){
		int key = static_cast<EventKeyboard*>(event_ptr)->getKey();
		if(key == 27){ // escape key; end the game
			GameManager &game_manager = GameManager::getInstance();
			game_manager.stop();
		}
		return 1;
	}
	return 0;
}

