// Clock.cpp
// Brian Seney
// IMGD3000

#include <iostream>
#include "Clock.h"

using namespace std;

// Initialize the clock
Clock::Clock(){
	timespec temp;
	clock_gettime(CLOCK_REALTIME, &temp);
	previous_time = temp;
}

// Return difference between current time and previous time
// Previous time is then updated to the current time
long int Clock::delta_t(){
	timespec temp;
	clock_gettime(CLOCK_REALTIME, &temp);
	timespec current_time = temp;
	
	// Convert to microseconds
	long int current_mic = current_time.tv_sec * 1000000
		+ current_time.tv_nsec / 1000;
	long int previous_mic = previous_time.tv_sec * 1000000
		+ previous_time.tv_nsec / 1000;
	long int elapsed = current_mic - previous_mic;
	// Update the previous time to the current time
	previous_time = temp;

	// Return the difference
	return elapsed;
}
