// EventCollision.h
// Brian Seney
// IMGD3000

#ifndef __EVENTCOLLISION_H__
#define __EVENTCOLLISION_H__

#include "Event.h"
#include "Position.h"
#include "GameObject.h"

#define COLLISION_EVENT "collision"

class EventCollision : public Event{
	protected:
	Position collision_pos;
	GameObject *obj1;
	GameObject *obj2;

	public:
	EventCollision(){ type = COLLISION_EVENT; }
	// Create the collision event; set the position and colliding objects
	EventCollision(GameObject *first, GameObject *second, Position pos){
		collision_pos = pos;
		obj1 = first;
		obj2 = second;
	}

	// Getters, setters
	GameObject* getObj1(){ return obj1; }
	void setObj1(GameObject *new_obj1){ obj1 = new_obj1; }
	GameObject* getObj2(){ return obj2; }
	void setObj2(GameObject *new_obj2){ obj2 = new_obj2; }
	Position getPos(){ return collision_pos; }
	void setPos(Position new_pos){ collision_pos = new_pos; }
};

#endif // __EVENTCOLLISION_H__
