// EventManager.h
// Brian Seney
// IMGD3000

#ifndef __EVENTMANAGER_H__
#define __EVENTMANAGER_H__

#include "Manager.h"
#include "GameObjectList.h"
#include "Event.h"

#include <string>

const int MAX_EVENTS = 100;

using namespace std;

class EventManager : public Manager{
	private:
	string event_name[MAX_EVENTS];
	GameObjectList obj_list[MAX_EVENTS];
	int num_events;

	// Prohibit copy, assignment
	EventManager(EventManager const&){}
	void operator=(EventManager const&){}

	// Private constructor, destructor
	EventManager(){}
	~EventManager(){}

	public:
	// Start, stop the event manager
	int startUp();
	int shutDown();

	// Broadcast the event to all interested objects
	void sendEvent(Event* e);

	// Register, unregister the given object to receive the given event
	void registerInterest(GameObject* obj_ptr, string event_type);
	void removeInterest(GameObject* obj_ptr, string event_type);

	// Return the EventManager instance
	static EventManager& getInstance(){
		static EventManager manager;
		return manager;
	}
};

#endif // __EVENTMANAGER_H__
	
