// GameManager.h
// Brian Seney
// IMGD3000

#ifndef __GAMEMANAGER_H__
#define __GAMEMANAGER_H__

#include "Clock.h"
#include "Manager.h"
#include <stdlib.h>

#define FRAME_TICKS 33000

class GameManager : public Manager{
	private:	
	// The frame rate for the game
	int frame_rate;
	// Is the game running?
	bool is_running;

	// Prohibit copy, assignment
	GameManager(GameManager const&){}
	void operator=(GameManager const&){}

	GameManager(){}
	~GameManager(){ shutDown(); }

	public:
	// Start, stop the GameManager
	int startUp(int debug, bool append);
	int shutDown();

	// Start, stop the game loop
	void run();
	void stop();

	// Return the GameManager instance
	static GameManager& getInstance(){
		static GameManager manager;
		return manager;
	}
};

#endif // __GAMEMANAGER_H__
