// GameObjectList.cpp
// Brian Seney
// IMGD3000

#include "GameObjectList.h"

void GameObjectList::add(GameObject *obj_ptr){
	// make sure the object is not already in the list
	if(obj_ptr != NULL && find(obj_ptr) == NULL)
		obj_list.push_back(obj_ptr);
}

void GameObjectList::remove(GameObject *obj_ptr){
	obj_list.remove(obj_ptr);		
}

void GameObjectList::clear(){
	obj_list.clear();
}

GameObject* GameObjectList::find(int id){
	// Iterate through, searching for the id
	list<GameObject*>::iterator iter = obj_list.begin();
	while(iter != obj_list.end() ){
		if ( (*iter)->getId() == id)
			return *iter;
		iter++;
	}
	// If reached this point, the object was not found
	return NULL;
}

GameObject* GameObjectList::find(GameObject* obj_ptr){
	// Iterate through, searching for the pointer
	list<GameObject*>::iterator iter = obj_list.begin();
	while(iter != obj_list.end() ){
		if ( *iter == obj_ptr)
			return *iter;
		iter++;
	}
	// If reached this point, the object was not found
	return NULL;
}

