// GameObjectList.h
// Brian Seney
// IMGD3000

#ifndef __GAMEOBJECTLIST_H__
#define __GAMEOBJECTLIST_H__

#include "GameObject.h"
#include <list>

class GameObjectList{
	private:
	// A list of pointers to GameObjects
	list<GameObject*> obj_list;

	public:
	GameObjectList(){}
	~GameObjectList(){}

	// Add game object pointer
	void add(GameObject *obj_ptr);
	// Remove given object pointer from list
	void remove(GameObject *obj_ptr);
	// Clear the list
	void clear();
	// Find and return a pointer to the object with the given id
	GameObject *find(int id);
	GameObject *find(GameObject *obj_ptr);
	// Return number of objects in the list
	int numObjects(){ return obj_list.size(); }

	// Iterator operations
	list<GameObject*>::iterator begin(){ return obj_list.begin(); }
	list<GameObject*>::iterator end(){ return obj_list.end(); }
};

#endif // __GAMEOBJECTLIST_H__
