// InputManager.h
// Brian Seney
// IMGD3000

#ifndef __INPUTMANAGER_H__
#define __INPUTMANAGER_H__

#include "Manager.h"
#include "GameObjectList.h"

class InputManager : public Manager{
	private:
	// The list of objects registered for these events
	GameObjectList key_objs;
	GameObjectList mouse_objs;

	// Prohibit copy, assignment
	InputManager(InputManager const&){};
	void operator=(InputManager const&){};

	// Private constructor, destructor
	InputManager(){}
	~InputManager(){}


	public:
	// Start, stop the input manager
	int startUp();
	int shutDown();

	// Obtain input from the keyboard and mouse; send to all interested objects
	void getInput();

	// Return the InputManager instance
	static InputManager& getInstance(){
		static InputManager manager;
		return manager;
	}

};

#endif // __INPUTMANAGER_H__
