// LogManager.h
// Brian Seney, Alfredo Porras
// IMGD 3000

#ifndef __LOGMANAGER_H__
#define __LOGMANAGER_H__

#include <string>
#include <fstream>
#include <time.h>
#include <stdarg.h>
#include <iostream> // check

#include "Manager.h"

using namespace std;

class LogManager : public Manager{
	private:
	int debug_level;
	ofstream logfile;

	// Prohibit copy, assignment.
	LogManager(LogManager const&){};
	void operator=(LogManager const&){};

	// Private constructor, destructor
	LogManager(){}
	~LogManager(){}

	string getTime();

	public:
	// Start, stop the log manager
	int startUp(int debug, bool append);
	int shutDown();

	// Write to the file
	void writeLog(int debug, char* str, ...);

	// Return the LogManager instance
	static LogManager& getInstance(){
		static LogManager manager;
		return manager;
	}
};

#endif // __LOGMANAGER_H__
