// Alfredo Porras
// Brian Seney
// IMGD 3000

// Path Search

#ifndef __PATH_SEARCH_H__
#define __PATH_SEARCH_H__

#include <queue>
#include <vector>
#include <stack>
#include "PathSearchNode.h"
#include "ComparePathNode.h"
#include "Position.h"

class PathSearch {
	private:
		vector<PathSearchNode *> visited;
		priority_queue<PathSearchNode, vector<PathSearchNode>, ComparePathNode> fringe;
//		stack<PathSearchNode *> final_path; // or put this into the searching agent itself
		bool isGoal(Position current);
		void expand(PathSearchNode node); //, PathSearchNode *p_parent
		Position goal;
		PathSearchNode *visitedNode(PathSearchNode n);
		
		void cleanVisited();

	public:
		PathSearch();
		~PathSearch();
		void findPath(Position start, Position end, stack<Position> *p_path_stack);

};

#endif // __PATH_SEARCH_H__
