// ResourceManager.h
// Brian Seney
// IMGD3000

#ifndef __RESOURCEMANAGER_H__
#define __RESOURCEMANAGER_H__

#include "Manager.h"
#include "Sprite.h"
#include "Frame.h"

using namespace std;

class ResourceManager : public Manager{
	private:
	// Prohibit copy, assignment
	ResourceManager(ResourceManager const&){};
	void operator=(ResourceManager const&){};

	// Private constructor, destructor
	ResourceManager(){}
	~ResourceManager(){}

	public:
	// Start, stop the resource manager
	int startUp();
	int shutDown();

	// Load a sprite from the given file (if it exists, null otherwise)
	Sprite* loadSprite(string filename);

	// Read the line, and find the integer following the expected string
	int line_to_int(ifstream* file, string expect);

	// Read the frame in from the file
	Frame *frame_read(ifstream* file, int width, int height);
	// Read the colors in for the given frame
	vector<int> *frame_color_read(ifstream* file, int width, int height);

	// Return the ResourceManager instance
	static ResourceManager& getInstance(){
		static ResourceManager manager;
		return manager;
	}
};

#endif // __RESOURCEMANAGER_H__
