// Sprite.h
// Brian Seney
// IMGD3000

#ifndef __SPRITE_H__
#define __SPRITE_H__

#include "Frame.h"
#include <string>
#include <vector>

using namespace std;

class Sprite{
	private:
	int width;
	int height;
	int numFrames;

	string label;
	vector<Frame*> frame_vec;

	Sprite(){ numFrames = 0; };

	public:
	~Sprite(){};
	
	// Getters, setters
	int getWidth(){ return width; }
	void setWidth(int new_width){ width = new_width; }
	int getHeight(){ return height; }
	void setHeight(int new_height){ height = new_height; }
	string getLabel(){ return label; }
	void setLabel(string new_label){ label = new_label; }
	int getNumFrames(){ return numFrames; }
	
	Frame *getFrame(int num){ 
		if(num < frame_vec.size())
			return frame_vec[num]; 
	}
	void addFrame(Frame *new_frame){ 
		frame_vec.push_back(new_frame);
		numFrames++;
	}

	// Allow the resource manager to create sprites
	friend class ResourceManager;
};

#endif // __SPRITE_H__
