// EventBallSteal.h
// Brian Seney, Alfredo Porras
// IMGD3000

#ifndef __EVENTBALLSTEAL_H__
#define __EVENTBALLSTEAL_H__

#include "Engine/Event.h"
#include "Engine/GameObject.h"
#include "Ball.h"
#include "Player.h"

#define BALL_STEAL_EVENT "ballsteal"

// When sent, informs any player holding ball 'ball_ptr' to release it
class EventBallSteal : public Event{
	protected:
	Ball* ball_ptr;
	GameObject* player_ptr; // the object taking the ball

	public:
	EventBallSteal(Ball* stolen_ball){
		ball_ptr = stolen_ball;
		player_ptr = NULL;
		type = BALL_STEAL_EVENT;
	}
	EventBallSteal(Ball* stolen_ball, GameObject* stolen_player){
		ball_ptr = stolen_ball;
		player_ptr = stolen_player;
		type = BALL_STEAL_EVENT;
	}

	Ball* getStolenBall(){ return ball_ptr; }
	void setStolenBall(Ball* new_stolen_ball){ ball_ptr = new_stolen_ball; }
	GameObject* getStolenPlayer(){ return player_ptr; }
	void setStolenPlayer(GameObject* new_stolen_player){ player_ptr = new_stolen_player; }
};

#endif // __EVENTBALLSTEAL_H__
