// Goal.cpp
// Brian Seney, Alfredo Porras
// IMGD3000

#include "Goal.h"
#include "Engine/WorldManager.h"
#include "Engine/GraphicsManager.h"
#include "Engine/ResourceManager.h"
#include "Engine/EventManager.h"

Goal::Goal(){
	object_type = GOAL_TYPE;

	ResourceManager &resource_manager = ResourceManager::getInstance();
	sprite_ptr = resource_manager.loadSprite("Sprites/Goal.txt");
	obj_box = Box(pos, sprite_ptr->getWidth(), sprite_ptr->getHeight());

	sprite_index = 0;

	WorldManager &world_manager = WorldManager::getInstance();
	world_manager.addObj(this);
}

Goal::~Goal(){}

int Goal::eventHandler(Event *event_ptr){
	return 0;
}

void Goal::draw(){
	GraphicsManager &graph_manager = GraphicsManager::getInstance();
	graph_manager.drawFrame(pos, sprite_ptr->getFrame(sprite_index));
	//graph_manager.drawCh(pos, 'X', 1);
}
