// Opponent.h
// Alfredo Porras, Brian Seney
// IMGD 3000

#ifndef __OPPONENT_H__
#define __OPPONENT_H__

#include "Engine/GameObject.h"
#include "Engine/Event.h"

#define OPPONENT_TYPE "opponent"

class Opponent : public GameObject {
	protected:
		int health;
		bool do_attack;
		int move_slowdown;
		int move_countdown;
		int direction; // 1: up, 2: right, 3: down, 4:left
		int direction_count;
		int direction_countdown;
		Position target;
		virtual void move();
		virtual void attack();

		char display_char;
		int color;

	public:
		Opponent();
		~Opponent();

		virtual int eventHandler(Event *event_ptr);

		virtual void draw();
};

#endif // __OPPONENT_H__
