// OpponentBig.cpp
// Brian Seney, Alfredo Porras
// IMGD 3000

#include "OpponentBig.h"
#include "Engine/ResourceManager.h"

OpponentBig::OpponentBig(){
	sprite_countdown = 0;
	sprite_slowdown = 5;
	sprite_index = 0;

	ResourceManager &resource_manager = ResourceManager::getInstance();
	sprite_ptr = resource_manager.loadSprite("Sprites/OpponentBig.txt");
	obj_box = Box(pos, sprite_ptr->getWidth(), sprite_ptr->getHeight());
}

OpponentBig::~OpponentBig(){}

void OpponentBig::draw(){
	GraphicsManager &graph_manager = GraphicsManager::getInstance();

	// Find the frame to draw
	sprite_countdown--;
	// If ready to draw a new frame, increase the index
	if(sprite_countdown < 0){
		sprite_countdown = sprite_slowdown;
		sprite_index++;
		if(sprite_index >= sprite_ptr->getNumFrames() ){
			sprite_index = 0;
		}
	}
	graph_manager.drawFrame(pos, sprite_ptr->getFrame(sprite_index));
}
