// OpponentGunZombie.cpp
// Alfredo Porras, Brian Seney
// IMGD 3000

#include <cmath>

#include "Engine/EventManager.h"

#include "OpponentGunZombie.h"
#include "EventTargetMovement.h"
#include "Arrow.h"
#include "EnemyArrow.h"

OpponentGunZombie::OpponentGunZombie() {
	display_char = 'W';
	color = 6;

	move_slowdown = 20;

	health = 1;
//	sight_radius = 15;
	shot_cooldown = 10;
	shot_countdown = shot_cooldown;
	shooting_distance = 5;
//	EventManager &event_manager = EventManager::getInstance();
//	event_manager.registerInterest(this, TARGETMOVEMENT_EVENT);
}

OpponentGunZombie::OpponentGunZombie(int sight) {
	sight_radius = sight;
	shot_cooldown = 5;
	shot_countdown = shot_cooldown;

//	EventManager &event_manager = EventManager::getInstance();
//	event_manager.registerInterest(this, TARGETMOVEMENT_EVENT);
}

OpponentGunZombie::OpponentGunZombie(int sight, int shot_freq) {
	sight_radius = sight;
	shot_cooldown = shot_freq;
	shot_countdown = shot_cooldown;

//	EventManager &event_manager = EventManager::getInstance();
//	event_manager.registerInterest(this, TARGETMOVEMENT_EVENT);
}

OpponentGunZombie::~OpponentGunZombie() {
//	EventManager &event_manager = EventManager::getInstance();
//	event_manager.removeInterest(this, TARGETMOVEMENT_EVENT);
}

int OpponentGunZombie::eventHandler(Event *event_ptr) {
	if (event_ptr->getType() == STEP_EVENT) {
		if(!do_attack) {
			move();
		}
		else {
			attack(); // fix
		}
		return 1;
	}
	if (event_ptr->getType() == COLLISION_EVENT) {
		EventCollision *collision_ptr = static_cast<EventCollision*>(event_ptr);
		GameObject *obj_ptr = collision_ptr->getObj2();
		// If colliding with a weapon, take damage.
		if(obj_ptr->getType().compare( BULLET_TYPE ) == 0){
			health -= static_cast<Bullet*>(obj_ptr)->getDamage();
			if(health <= 0){
				WorldManager &world_manager = WorldManager::getInstance();
				world_manager.markForDelete(this);
			}
		}
		return 1;
	}
	if (event_ptr->getType() == TARGETMOVEMENT_EVENT) {
		EventTargetMovement *p_etm = static_cast <EventTargetMovement *> (event_ptr);
		if(isClose(p_etm->getTargetPos())) {
			do_attack = true;
			target = p_etm->getTargetPos();
		}
		else {
			do_attack = false; // probably cheaper to do this every movement than checking other conditions
		}
		return 1;
	}
	
}

// bool OpponentGunZombie::isClose(Position targ) {
	// if (abs(targ.get_x() - pos.get_x()) < sight_radius) {
		// if (abs(targ.get_y() - pos.get_y()) < sight_radius) {
			// return true;
		// }
	// }
	// return false;
// }

// void OpponentGunZombie::move() {
	// move_countdown--;
	// if (move_countdown > 0) {
		// return;
	// }
	// move_countdown = move_slowdown;

	// Position new_pos;
	// direction = (random() % 4) + 1;
	// switch(direction) {
		// case 1:
		// {
			// new_pos.set_x( pos.get_x() );
			// new_pos.set_y( pos.get_y() + 1);
			// break;
		// }
		// case 2:
		// {
			// new_pos.set_x( pos.get_x() - 1);
			// new_pos.set_y( pos.get_y() );
			// break;
		// }
		// case 3:
		// {
			// new_pos.set_x( pos.get_x() );
			// new_pos.set_y( pos.get_y() - 1);
			// break;
		// }
		// case 4:
		// {
			// new_pos.set_x( pos.get_x() + 1);
			// new_pos.set_y( pos.get_y() );
			// break;
		// }

	// }

	// // If the object could not be moved, try next time
	// WorldManager &world_manager = WorldManager::getInstance();
	// if(world_manager.moveObj(this, new_pos) == 1){
		// return;
	// }
// }

void OpponentGunZombie::attack() {
	move_countdown--;
	if (move_countdown > 0) {
		return;
	}
	move_countdown = move_slowdown;
	
	WorldManager &world_manager = WorldManager::getInstance();
	if (abs(target.get_x() - pos.get_x()) >= shooting_distance) {
		if (target.get_x() > pos.get_x()) {
			world_manager.moveObj(this, Position(pos.get_x() + 1, pos.get_y()));
		}
		else if (target.get_x() < pos.get_x()) {
			world_manager.moveObj(this, Position(pos.get_x() - 1, pos.get_y()));
		}
	}
	else if (abs(target.get_y() - pos.get_y()) >= shooting_distance) {
		if (target.get_y() > pos.get_y()) {
			world_manager.moveObj(this, Position(pos.get_x(), pos.get_y() + 1));
		}
		else if (target.get_y() < pos.get_y()) {
			world_manager.moveObj(this, Position(pos.get_x(), pos.get_y() - 1));
		}
	}
	else { // good shooting range
		if ((target.get_x() != pos.get_x()) && target.get_y() != pos.get_y()) {
			// not in line of fire
			// adjust y coordinate for now
			if (target.get_y() > pos.get_y()) {
				world_manager.moveObj(this, Position(pos.get_x(), pos.get_y() + 1));
			}
			else if (target.get_y() < pos.get_y()) {
				world_manager.moveObj(this, Position(pos.get_x(), pos.get_y() - 1));
			}
		}
	}
	tryFire();
}

bool OpponentGunZombie::isCloseEnough(Position targ) {
	if (abs(targ.get_x() - pos.get_x()) <= shooting_distance) {
		if (abs(targ.get_y() - pos.get_y()) <= shooting_distance) {
			return true;
		}
	}
	return false;
}

bool OpponentGunZombie::tryFire() {
	shot_countdown--;
	if (shot_countdown > 0) {
		return false;
	}
	shot_countdown = shot_cooldown;

	if(target.get_x() == pos.get_x()) {
		if (target.get_y() > pos.get_y()) {
			new EnemyArrow( pos.get_x(), pos.get_y() + 1, 0, 1);
		}
		else if (target.get_y() < pos.get_y()) {
			new EnemyArrow( pos.get_x(), pos.get_y() - 1, 0, 0 -1);
		}
	}
	else if(target.get_y() == pos.get_y()) {
		if (target.get_x() > pos.get_x()) {
			new EnemyArrow( pos.get_x() + 1, pos.get_y(), 1, 0);
		}
		else if (target.get_x() < pos.get_x()) {
			new EnemyArrow( pos.get_x() - 1, pos.get_y(), -1, 0);
		}
	}
	else {
		return false;
	}
	return true;

// right now it shoots in the direction it moved last
/*	if ((target.get_x() == pos.get_x())||(target.get_y() == pos.get_y())) {
		if ((old_pos.get_x() - pos.get_x() < 0)){
			gun->shootWeapon( pos.get_x() + 1, pos.get_y(), 1, 0, 0, 0 );
		}
		else if ((old_pos.get_x() - pos.get_x() > 0)) {
			gun->shootWeapon( pos.get_x() - 1, pos.get_y(), -1, 0, 0, 0 );
		}
		else if ((old_pos.get_y() - pos.get_y() < 0)) {
			gun->shootWeapon( pos.get_x(), pos.get_y() + 1, 0, 1, 0, 0 );
		}
		else if ((old_pos.get_y() - pos.get_y() > 0)) {
			gun->shootWeapon( pos.get_x(), pos.get_y() - 1, 0, 0 -1, 0, 0 );
		}
		else {
			return false;
		}
		return true;
	}
	*/
}


