// PostLevelPicture.cpp
// Brian Seney, Alfredo Porras
// IMGD3000

#include "PostLevelPicture.h"
#include "PreLevelPicture.h"

PostLevelPicture::PostLevelPicture(string this_sprite, string pre_lvl_sprite, string level_to_load){
	// if the passed string is not the empty string
	if(this_sprite.length() > 0){
		ResourceManager &resource_manager = ResourceManager::getInstance();
		Sprite *spr_ptr = resource_manager.loadSprite(this_sprite);
		sprite_ptr = spr_ptr;

		level = level_to_load;
		next_level_sprite = pre_lvl_sprite;

		WorldManager &world_manager = WorldManager::getInstance();
		world_manager.addObj(this);

		EventManager &event_manager = EventManager::getInstance();
		event_manager.registerInterest(this, STEP_EVENT);
	}
}

PostLevelPicture::~PostLevelPicture(){
	EventManager &event_manager = EventManager::getInstance();
	event_manager.removeInterest(this, STEP_EVENT);

	// if the level passed to this is not the empty string
	if(level.length() > 0 && next_level_sprite.length() > 0){
		new PreLevelPicture(next_level_sprite, level);
	}
}
