// RogueBall.cpp
// Brian Seney, Alfredo Porras
// IMGD 3000

#include "Engine/Clock.cpp"
#include "Engine/GameObject.cpp"
#include "Engine/GameObjectList.cpp"

#include "Engine/Manager.cpp"
#include "Engine/WorldManager.cpp"
#include "Engine/InputManager.cpp"
#include "Engine/GraphicsManager.cpp"
#include "Engine/EventManager.cpp"
#include "Engine/GameManager.cpp"
#include "Engine/LogManager.cpp"
#include "Engine/ResourceManager.cpp"
#include "Engine/PathSearch.cpp"

#include "Picture.cpp"
#include "Player.cpp"
#include "Ball.cpp"
#include "Opponent.cpp"
#include "OpponentDrunk.cpp"
#include "OpponentZombie.cpp"
#include "OpponentGunZombie.cpp"
#include "OpponentHunter.cpp"
#include "Sword.cpp"
#include "Arrow.cpp"
#include "Goal.cpp"
#include "GameController.cpp"
#include "Spawner.cpp"
#include "PreLevelPicture.cpp"
#include "PostLevelPicture.cpp"
#include "EndGamePicture.cpp"
#include "Block.cpp"
#include "BlockBreakable.cpp"
#include "BlockMovable.cpp"
#include "Weapon.cpp"
#include "Bomb.cpp"
#include "TitleScreen.cpp"
#include "EnemyArrow.cpp"
#include "OpponentBig.cpp"
#include "OpponentSpawner.cpp"
#include "OpponentBallSteal.cpp"
#include "Boss.cpp"

#include <string>
#include <iostream>

using namespace std;

int main(int argc, char *argv[]){
	bool append = false;
	int debug = 1;

	// Command line arguments	
	if(argc > 1){
		for(int i = 0; i < argc; i++){
			char* argument = argv[i];
			// -t : append to logfile on startup (default overwrite)
			if(strcmp(argument, "-t") == 0){
				append = true;
			// -d X : debug level X
			} else if(strcmp(argument, "-d") == 0){
				// if there is an argument after the current
				if(i + 1 < argc){
					debug = atoi( argv[i + 1] );
				}
			}			
		}
	}

	GameManager &game_manager = GameManager::getInstance();
	game_manager.startUp(debug, append);

	LogManager &log_manager = LogManager::getInstance();
	log_manager.writeLog(1, "Debug Level: %i", debug);

	new TitleScreen();

	game_manager.run();

	game_manager.shutDown();

	return 0;
}
