// Spawner.h
// Brian Seney, Alfredo Porras
// IMGD3000

#ifndef __SPAWNER_H__
#define __SPAWNER_H__

#include "Engine/GameObject.h"
#include "Engine/Event.h"

class Spawner : public GameObject{
	private:
	int spawn_countdown;
	int spawn_slowdown;
	bool score_spawn; // if the spawner spawns objects on score events
	
	void(*function_pointer)(int x_pos, int y_pos);

	public:
	Spawner( void(*fp)(int x_pos, int y_pos) );
	~Spawner();

	int getSpawnSlowdown(){ return spawn_slowdown; }
	void setSpawnSlowdown(int new_slowdown){ spawn_slowdown = new_slowdown; }
	bool getScoreSpawn(){ return score_spawn; }
	void setScoreSpawn(bool new_score_spawn){ score_spawn = new_score_spawn; }

	int eventHandler(Event *event_ptr);

	void draw();
};

#endif // __SPAWNER_H__
	
