// Sword.cpp
// Brian Seney, Alfredo Porras
// IMGD3000

#include "Sword.h"
#include "Engine/WorldManager.h"
#include "Engine/GraphicsManager.h"

Sword::Sword(int x, int y){
	object_type = BULLET_TYPE;

	damage = 5;
	time_to_live = 4;

	display_char = ' ';
	color = 8;

	EventManager &event_manager = EventManager::getInstance();
	event_manager.registerInterest(this, STEP_EVENT);
	event_manager.registerInterest(this, COLLISION_EVENT);

	WorldManager &world_manager = WorldManager::getInstance();
	world_manager.addObj(this);
	world_manager.moveObj(this, Position(x, y));
}

Sword::~Sword(){
	EventManager &event_manager = EventManager::getInstance();
	event_manager.removeInterest(this, STEP_EVENT);
	event_manager.removeInterest(this, COLLISION_EVENT);
}

int Sword::eventHandler(Event *event_ptr){
	if(event_ptr->getType().compare(STEP_EVENT) == 0){
		time_to_live--;
		if(time_to_live == 0){
			WorldManager &world_manager = WorldManager::getInstance();
			world_manager.markForDelete(this);
		}
		return 1;
	} else if(event_ptr->getType().compare(COLLISION_EVENT) == 0){
		WorldManager &world_manager = WorldManager::getInstance();
		world_manager.markForDelete(this);
		return 1;
	}
	return 0;
}
