// Weapon.h
// Brian Seney, Alfredo Porras
// IMGD3000

#ifndef __WEAPON_H__
#define __WEAPON_H__

#include "Engine/GameObject.h"
#include "Engine/Event.h"

#define WEAPON_TYPE "weapon"
#define TRIPLE_SHOT_TYPE "triple"
#define BOMB_TYPE "bomb"
#define TRIPLE_BOMB_TYPE "tbomb"

class Weapon : public GameObject{
	protected:
	string weapon_type;
	int color;
	char display_char;

	int slowdown; // the time it takes to fire the weapon again
	int slowdown_count;

	public:
	Weapon();
	~Weapon();

	// Shoot the weapon in the given direction
	void shootWeapon(int pos_x, int pos_y, float vel_x, float vel_y, float accel_x, float accel_y);

	string getWeaponType(){ return weapon_type;}
	void setWeaponType(string new_weapon_type){ weapon_type = new_weapon_type; }
	int getColor(){ return color; }
	void setColor(int new_color){ color = new_color; }
	char getChar(){ return display_char; }
	void setChar(int new_char){ display_char = new_char; }
	int getSlowdown(){ return slowdown; }
	void setSlowdown(int new_slowdown){ slowdown = new_slowdown; }

	int eventHandler(Event *event_ptr);
};

#endif // __WEAPON_H__
